require "test_helper"

class MenuOptionsControllerTest < ActionDispatch::IntegrationTest
  setup do
    @menu_option = menu_options(:one)
  end

  test "should get index" do
    get menu_options_url
    assert_response :success
  end

  test "should get new" do
    get new_menu_option_url
    assert_response :success
  end

  test "should create menu_option" do
    assert_difference("MenuOption.count") do
      post menu_options_url, params: { menu_option: { batch_id: @menu_option.batch_id, menu_id: @menu_option.menu_id } }
    end

    assert_redirected_to menu_option_url(MenuOption.last)
  end

  test "should show menu_option" do
    get menu_option_url(@menu_option)
    assert_response :success
  end

  test "should get edit" do
    get edit_menu_option_url(@menu_option)
    assert_response :success
  end

  test "should update menu_option" do
    patch menu_option_url(@menu_option), params: { menu_option: { batch_id: @menu_option.batch_id, menu_id: @menu_option.menu_id } }
    assert_redirected_to menu_option_url(@menu_option)
  end

  test "should destroy menu_option" do
    assert_difference("MenuOption.count", -1) do
      delete menu_option_url(@menu_option)
    end

    assert_redirected_to menu_options_url
  end
end
